import { interfaces } from 'inversify';
import { Feature } from '@common-stack/server-core';
import { TaggedType } from '@common-stack/core';

import {preferences} from './preferences';
import { TYPES } from './constants';
import { IOutputService } from './interfaces';
import { resolver, schema } from './graphql';
import { outputModule, outputModuleMicroservice } from './container';
import { OuputMoleculerService } from './plugin';

const outputServiceGen = (container: interfaces.Container) => {
        return { outputService: container.getNamed<IOutputService>(TYPES.IOutputService, TaggedType.MICROSERVICE) };
};

export default new Feature({
    schema,
    createResolversFunc: resolver,
    createPreference: preferences,
    createServiceFunc: outputServiceGen,
    createContainerFunc: [outputModuleMicroservice],
    createHemeraContainerFunc: [outputModule],
    addBrokerClientServiceClass: [OuputMoleculerService],
});
