import { get } from 'lodash';
import { IOutputService } from '../interfaces';

export const setupProjects = async (service: IOutputService, logger, podConfig) => {
    try {
        const pods = get(podConfig, 'POD');
        pods.forEach(pod => {
            const containers = pod.containers;
            if (containers) {
                containers.forEach(container => {
                    service.addNewType(`${pod.podName}-${container.container}`, {
                        container: container.container,
                        name: `${pod.podName}-${container.container}`,
                        podName: pod.podName,
                        nameSpace: pod.nameSpace,
                        podQuery: pod.podQuery,
                        title: container.title ? container.title : pod.title,
                    });
                });
            } else {
                service.addNewType(pod.podName, {name: pod.podName, podName: pod.podName, title: pod.title, nameSpace: pod.nameSpace, podQuery: pod.podQuery});
            }
        });
    } catch (e) {
        console.error('e', e);
    }
};
